     Program

!=====================================================================================================
! Delay() will pause for 'r' seconds and will optionally display a window with countdown progress bar.
! It uses the window timer for low CPU utilization and it won't adversely affect your other programs
! like a closed loop would.
!-----------------------------------------------------------------------------------------------------
! (C) 1996 Grebar Systems Inc. You may use this software as long as no money is charged for it.
! Author: Barry McClure CIS: 75170,1100  Internet: support@grebar.mb.ca
!=====================================================================================================

  Map
    Delay(Real, <Byte>)
  .

  code
    delay(10)                    !Or use Delay(10,1) to hide the window.
    beep



!=================================================================================================
! Delay returning for "In:Sec" real seconds and display a window if optional In:Hide_Window <> 1
!=================================================================================================
Delay  Procedure(In:Sec, |
                 In:Hide_Window)

Progress      Real
Loc:Start_TM  Long
Loc:Start_DT  Long
Loc:Day_Sec   Real
Loc:Sec_Rem   Real

window WINDOW('Delay WIndow'),AT(,,163,57),FONT('Arial',10,,),TIMER(10),GRAY
       PROGRESS,USE(Progress),AT(20,12,123,8),RANGE(0,100)
       STRING('Seconds Remaining'),AT(58,2),USE(?String1)
       STRING(@n8.1),AT(23,2),USE(Loc:Sec_Rem)
       BUTTON('Cancel'),AT(109,34),USE(?Cancel)
     END

  code
    Loc:Start_TM = Clock()
    Loc:Start_DT = Today()                                      !Date is used in case delay occurs over midnight.

    open(window)
    if In:Hide_Window then
      window{Prop:hide} = 1
    .
    ?Progress{Prop:RangeHigh} = 100
    Progress = 100
    accept
      case Event()
        of Event:Timer
          Loc:Day_Sec = (Today() - Loc:Start_DT) * 86400        !Exit loop if In:Sec seconds have elapsed.
          Loc:Sec_Rem = In:Sec - (Loc:Day_Sec + (Clock()-Loc:Start_TM)/100.0)
          if Loc:Sec_Rem <= 0 then
            Post(Event:CloseWindow)
          .
          Progress = (Loc:Sec_Rem / In:Sec) * 100
          display(?Progress)
      .
      case Field()
        of ?Cancel
          case Event()
            of Event:Accepted
              Post(Event:CloseWindow)
          .
      .
    .
    close(Window)
    return
